export type TidalAddToPlaylistResponse = {
  errors: TidalAddToPlaylistError[];
};

export type TidalAddToPlaylistError = TidalError & {
  id: string;
  status: number;
  source: TidalAddToPlaylistErrorSource;
};

export type TidalAddToPlaylistErrorSource = {
  parameter: string;
};
export type TidalErrorMeta = {
  category: string;
};
export type TidalError = {
  code: string;
  detail: string;
  meta: TidalErrorMeta;
};
export type TidalErrorCode =
  | 'INVALID_ENUM_VALUE'
  | 'VALUE_REGEX_MISMATCH'
  | 'NOT_FOUND'
  | 'METHOD_NOT_SUPPORTED'
  | 'NOT_ACCEPTABLE'
  | 'UNSUPPORTED_MEDIA_TYPE'
  | 'UNAVAILABLE_FOR_LEGAL_REASONS_RESPONSE'
  | 'INTERNAL_SERVER_ERROR'
  | 'UNAUTHORIZED';

export type TidalAlbumResponse = {
  data?: TidalAlbumTrack[];
  links?: {
    next?: string;
    self: string;
  };
  errors?: TidalError[];
};
export type TidalAlbumTrack = {
  id: string;
  type: 'tracks' | string;
  meta: TidalAlbumTrackMeta;
};

export type TidalAlbumTrackMeta = {
  trackNumber: number;
  volumeNumber: number;
};
