export type YoutubePlaylistItem = {
  kind: 'youtube#playlistItem';
  etag: string;
  id: string;
  snippet: {
    resourceId: {
      kind: string;
      videoId: string;
    };
  };
};
export type YoutubePlaylistItemResponse = YoutubeResponse & {
  kind: 'youtube#playlistItemListResponse';
  etag: string;
  nextPageToken: string;
  prevPageToken: string;
  pageInfo: {
    totalResults: number;
    resultsPerPage: number;
  };
  items: YoutubePlaylistItem[];
};
export type YoutubeResponse = {
  error?: YoutubeErrorResponse;
};
export type YoutubeErrorResponse = {
  errors: YoutubeError[];
  code: number;
  message: string;
};

export type YoutubeError = {
  domain: 'global' | string;
  reason: YoutubeErrorReason;
  message: string;
  locationType: string;
  location: string;
};

export type YoutubeErrorReason =
  | 'movedPermanently'
  | 'seeOther'
  | 'mediaDownloadRedirect'
  | 'notModified'
  | 'temporaryRedirect'
  | 'badRequest'
  | 'badBinaryDomainRequest'
  | 'badContent'
  | 'badLockedDomainRequest'
  | 'corsRequestWithXOrigin'
  | 'endpointConstraintMismatch'
  | 'invalid'
  | 'invalidAltValue'
  | 'invalidHeader'
  | 'invalidParameter'
  | 'invalidQuery'
  | 'keyExpired'
  | 'keyInvalid'
  | 'lockedDomainCreationFailure'
  | 'notDownload'
  | 'notUpload'
  | 'parseError'
  | 'required'
  | 'tooManyParts'
  | 'unknownApi'
  | 'unsupportedMediaProtocol'
  | 'unsupportedOutputFormat'
  | 'wrongUrlForUpload'
  | 'unauthorized'
  | 'authError'
  | 'expired'
  | 'lockedDomainExpired'
  | 'required'
  | 'dailyLimitExceeded402'
  | 'quotaExceeded402'
  | 'user402'
  | 'quotaExceeded'
  | 'rateLimitExceeded'
  | 'limitExceeded'
  | 'unknownAuth'
  | string; // many more
